'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _loreReactFormsBootstrap = require('lore-react-forms-bootstrap');

var _ConfigConnect = require('./ConfigConnect');

var _ConfigConnect2 = _interopRequireDefault(_ConfigConnect);

var _Template = require('lore-react-forms/Template');

var _Template2 = _interopRequireDefault(_Template);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Connect = null;

exports.default = {

  templates: {
    default: _Template2.default
  },

  typeFieldMap: {

    string: function string(name, attributes) {
      return _react2.default.createElement(_loreReactFormsBootstrap.TextField, {
        label: attributes.label,
        name: name
      });
    },

    dynamicString: function dynamicString(name, attributes) {
      Connect = Connect || (0, _ConfigConnect2.default)();
      return _react2.default.createElement(
        Connect,
        { callback: attributes.connect },
        _react2.default.createElement(_loreReactFormsBootstrap.DynamicTextField, {
          label: attributes.label,
          name: name,
          getMessage: attributes.getMessage
        })
      );
    },

    // text: function(name, attributes) {
    //   return (
    //     <TextField
    //       label={attributes.label}
    //       name={name}
    //       multiLine={true}
    //     />
    //   );
    // },
    //
    // checkbox: function(name, attributes) {
    //   return (
    //     <CheckboxField
    //       label={attributes.label}
    //       name={name}
    //     />
    //   );
    // },
    //
    // number: function(name, attributes) {
    //   return (
    //     <NumberField
    //       label={attributes.label}
    //       name={name}
    //     />
    //   );
    // },

    select: function select(name, attributes) {
      Connect = Connect || (0, _ConfigConnect2.default)();
      return _react2.default.createElement(
        Connect,
        { callback: attributes.getOptions },
        _react2.default.createElement(_loreReactFormsBootstrap.SelectField, {
          label: attributes.label,
          name: name,
          field: attributes.field || 'username'
        })
      );
    },

    autocomplete: function autocomplete(name, attributes) {
      Connect = Connect || (0, _ConfigConnect2.default)();
      return _react2.default.createElement(
        Connect,
        { callback: attributes.getOptions },
        _react2.default.createElement(_loreReactFormsBootstrap.AutoCompleteField, {
          label: attributes.label,
          name: name,
          field: attributes.field || 'username'
        })
      );
    }

  },

  typeActionMap: {

    cancel: function cancel(name, attributes) {
      return _react2.default.createElement(
        'button',
        {
          key: name,
          className: 'btn btn-default' },
        attributes.label || 'Cancel'
      );
    },

    submit: function submit(name, attributes, onSubmit) {
      return _react2.default.createElement(
        'button',
        {
          key: name,
          className: 'btn btn-primary',
          onClick: onSubmit },
        attributes.label || 'Submit'
      );
    }

  }

};
module.exports = exports['default'];